## git-annex 0.10

=== Makefile ===
all: git-annex docs

ghcmake=ghc -Wall -odir build -hidir build -O2 --make 

SysConfig.hs: configure.hs
	$(ghcmake) configure
	./configure

git-annex: SysConfig.hs
	$(ghcmake) git-annex

install:
	install -d $(DESTDIR)/usr/bin
	install git-annex $(DESTDIR)/usr/bin

# If ikiwiki is available, build static html docs suitable for being
# shipped in the software package.
ifeq ($(shell which ikiwiki),)
IKIWIKI=@echo "** ikiwiki not found, skipping building docs" >&2; true
else
IKIWIKI=ikiwiki
endif

test:
	$(ghcmake) test
	./test

docs:
	./mdwn2man git-annex 1 doc/git-annex.mdwn > git-annex.1
	$(IKIWIKI) doc html -v --wikiname git-annex --plugin=goodstuff \
		--no-usedirs --disable-plugin=openid --plugin=sidebar \
		--underlaydir=/dev/null --disable-plugin=shortcut \
		--disable-plugin=smiley

clean:
	rm -rf build git-annex git-annex.1 test configure SysConfig.hs
	rm -rf doc/.ikiwiki html

.PHONY: git-annex test install

=== debian/changelog ===
git-annex (0.10) unstable; urgency=low

  * In .gitattributes, the annex.numcopies attribute can be used
    to control the number of copies to retain of different types of files.
  * Bugfix: Always correctly handle gitattributes when in a subdirectory of
    the repository. (Had worked ok for ones like "*.mp3", but failed for
    ones like "dir/*".)
  * fsck: Fix warning about not enough copies of a file, when locations
    are known, but are not available in currently configured remotes.
  * precommit: Optimise to avoid calling git-check-attr more than once.
  * The git-annex-backend attribute has been renamed to annex.backend.

 -- Joey Hess <joeyh@debian.org>  Sun, 28 Nov 2010 19:28:05 -0400

git-annex (0.09) unstable; urgency=low

  * Add copy subcommand.
  * Fix bug in setkey subcommand triggered by move --to.

 -- Joey Hess <joeyh@debian.org>  Sat, 27 Nov 2010 17:14:59 -0400

git-annex (0.08) unstable; urgency=low

  * Fix `git annex add ../foo` (when ran in a subdir of the repo).
  * Add configure step to build process.
  * Only use cp -a if it is supported, falling back to cp -p or plain cp
    as needed for portability.
  * cp --reflink=auto is used if supported, and will make git annex unlock
    much faster on filesystems like btrfs that support copy on write.

 -- Joey Hess <joeyh@debian.org>  Sun, 21 Nov 2010 13:45:44 -0400

git-annex (0.07) unstable; urgency=low

  * find: New subcommand.
  * unused: New subcommand, finds unused data. (Split out from fsck.)
  * dropunused: New subcommand, provides for easy dropping of unused keys
    by number, as listed by the unused subcommand.
  * fsck: Print warnings to stderr; --quiet can now be used to only see
    problems.

 -- Joey Hess <joeyh@debian.org>  Mon, 15 Nov 2010 18:41:50 -0400

git-annex (0.06) unstable; urgency=low

  * fsck: Check if annex.numcopies is satisfied.
  * fsck: Verify the sha1 of files when the SHA1 backend is used.
  * fsck: Verify the size of files when the WORM backend is used.
  * fsck: Allow specifying individual files if fscking everything
    is not desired.
  * fsck: Fix bug, introduced in 0.04, in detection of unused data.

 -- Joey Hess <joeyh@debian.org>  Sat, 13 Nov 2010 16:24:29 -0400

git-annex (0.05) unstable; urgency=low

  * Optimize both pre-commit and lock subcommands to not call git diff
    on every file being committed/locked.
    (This actually also works around a bug in ghc, that caused
    git-annex 0.04 pre-commit to sometimes corrupt filename being read
    from git ls-files and fail. 
    See <http://hackage.haskell.org/trac/ghc/ticket/4493>
    The excessive number of calls made by pre-commit exposed the ghc bug.
    Thanks Josh Triplett for the debugging.)
  * Build with -O2.

 -- Joey Hess <joeyh@debian.org>  Thu, 11 Nov 2010 18:31:09 -0400

git-annex (0.04) unstable; urgency=low

  * Add unlock subcommand, which replaces the symlink with a copy of
    the file's content in preparation of changing it. The "edit" subcommand
    is an alias for unlock.
  * Add lock subcommand.
  * Unlocked files will now automatically be added back into the annex when
    committed (and the updated symlink committed), by some magic in the
    pre-commit hook.
  * The SHA1 backend is now fully usable.
  * Add annex.version, which will be used to automate upgrades
    between incompatible versions.
  * Reorganised the layout of .git/annex/
  * The new layout will be automatically upgraded to the first time
    git-annex is used in a repository with the old layout.
  * Note that git-annex 0.04 cannot transfer content from old repositories
    that have not yet been upgraded.
  * Annexed file contents are now made unwritable and put in unwriteable
    directories, to avoid them accidentially being removed or modified.
    (Thanks Josh Triplett for the idea.)
  * Add build dep on libghc6-testpack-dev. Closes: #603016
  * Avoid using runghc to run test suite as it is not available on all
    architectures. Closes: #603006

 -- Joey Hess <joeyh@debian.org>  Wed, 10 Nov 2010 14:23:23 -0400

git-annex (0.03) unstable; urgency=low

  * Fix support for file:// remotes.
  * Add --verbose
  * Fix SIGINT handling.
  * Fix handling of files with unusual characters in their name.
  * Fixed memory leak; git-annex no longer reads the whole file list
    from git before starting, and will be much faster with large repos.
  * Fix crash on unknown symlinks.
  * Added remote.annex-scp-options and remote.annex-ssh-options.
  * The backends to use when adding different sets of files can be configured
    via gitattributes.
  * In .gitattributes, the git-annex-backend attribute can be set to the
    names of backends to use when adding different types of files.
  * Add fsck subcommand. (For now it only finds unused key contents in the
    annex.)

 -- Joey Hess <joeyh@debian.org>  Sun, 07 Nov 2010 18:26:04 -0400

git-annex (0.02) unstable; urgency=low

  * Can scp annexed files from remote hosts, and check remote hosts for
    file content when dropping files.
  * New move subcommand, that makes it easy to move file contents from
    or to a remote.
  * New fromkey subcommand, for registering urls, etc.
  * git-annex init will now set up a pre-commit hook that fixes up symlinks
    before they are committed, to ensure that moving symlinks around does not
    break them.
  * More intelligent and fast staging of modified files; git add coalescing.
  * Add remote.annex-ignore git config setting to allow completly disabling
    a given remote.
  * --from/--to can be used to control the remote repository that git-annex
    uses.
  * --quiet can be used to avoid verbose output
  * New plumbing-level dropkey and addkey subcommands.
  * Lots of bug fixes.

 -- Joey Hess <joeyh@debian.org>  Wed, 27 Oct 2010 16:39:29 -0400

git-annex (0.01) unstable; urgency=low

  * First prerelease.

 -- Joey Hess <joeyh@debian.org>  Wed, 20 Oct 2010 12:54:24 -0400

=== debian/control ===
Source: git-annex
Section: utils
Priority: optional
Build-Depends: debhelper (>= 7.0.50), ghc6, libghc6-missingh-dev, libghc6-testpack-dev, ikiwiki, uuid
Maintainer: Joey Hess <joeyh@debian.org>
Standards-Version: 3.9.1
Vcs-Git: git://git.kitenet.net/git-annex
Homepage: http://git-annex.branchable.com/

Package: git-annex
Architecture: any
Section: utils
Depends: ${misc:Depends}, ${shlibs:Depends}, git | git-core, uuid, openssh-client
Description: manage files with git, without checking their contents into git
 git-annex allows managing files with git, without checking the file
 contents into git. While that may seem paradoxical, it is useful when
 dealing with files larger than git can currently easily handle, whether due
 to limitations in memory, checksumming time, or disk space.
 .
 Even without file content tracking, being able to manage files with git,
 move files around and delete files with versioned directory trees, and use
 branches and distributed clones, are all very handy reasons to use git. And
 annexed files can co-exist in the same git repository with regularly
 versioned files, which is convenient for maintaining documents, Makefiles,
 etc that are associated with annexed files but that benefit from full
 revision control.

## git-annex 0.11

=== Makefile ===
--- 
+++ 
@@ -30,7 +30,8 @@
 	$(IKIWIKI) doc html -v --wikiname git-annex --plugin=goodstuff \
 		--no-usedirs --disable-plugin=openid --plugin=sidebar \
 		--underlaydir=/dev/null --disable-plugin=shortcut \
-		--disable-plugin=smiley
+		--disable-plugin=smiley \
+		--exclude='news/.*'
 
 clean:
 	rm -rf build git-annex git-annex.1 test configure SysConfig.hs

=== debian/changelog ===
git-annex (0.11) unstable; urgency=low

  * If available, rsync will be used for file transfers from remote
    repositories. This allows resuming interrupted transfers.
  * Added remote.annex-rsync-options.
  * Avoid deleting temp files when rsync fails.
  * Improve detection of version 0 repos.
  * Add uninit subcommand. Closes: #605749

 -- Joey Hess <joeyh@debian.org>  Sat, 04 Dec 2010 17:27:42 -0400

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: git-annex
 Section: utils
 Priority: optional
-Build-Depends: debhelper (>= 7.0.50), ghc6, libghc6-missingh-dev, libghc6-testpack-dev, ikiwiki, uuid
+Build-Depends: debhelper (>= 7.0.50), ghc6, libghc6-missingh-dev, libghc6-testpack-dev, ikiwiki, uuid, rsync
 Maintainer: Joey Hess <joeyh@debian.org>
 Standards-Version: 3.9.1
 Vcs-Git: git://git.kitenet.net/git-annex
@@ -10,7 +10,7 @@
 Package: git-annex
 Architecture: any
 Section: utils
-Depends: ${misc:Depends}, ${shlibs:Depends}, git | git-core, uuid, openssh-client
+Depends: ${misc:Depends}, ${shlibs:Depends}, git | git-core, uuid, openssh-client, rsync
 Description: manage files with git, without checking their contents into git
  git-annex allows managing files with git, without checking the file
  contents into git. While that may seem paradoxical, it is useful when

## git-annex 0.13

=== debian/changelog ===
git-annex (0.13) unstable; urgency=low

  * Makefile: Install man page and html (when built).
  * Makefile: Add GHCFLAGS variable.
  * Fix upgrade from 0.03.
  * Support remotes using git+ssh and ssh+git as protocol.
    Closes: #607056

 -- Joey Hess <joeyh@debian.org>  Tue, 14 Dec 2010 13:05:10 -0400

git-annex (0.12) unstable; urgency=low

  * Add --exclude option to exclude files from processing.
  * mwdn2man: Fix a bug in newline supression. Closes: #606578
  * Bugfix to git annex add of an unlocked file in a subdir. Closes: #606579
  * Makefile: Add PREFIX variable.

 -- Joey Hess <joeyh@debian.org>  Sat, 11 Dec 2010 17:32:00 -0400

## git-annex 0.14

=== Makefile ===
PREFIX=/usr
GHCFLAGS=-O2 -Wall
GHCMAKE=ghc -odir build -hidir build $(GHCFLAGS) --make

all: git-annex git-annex.1 docs

SysConfig.hs: configure.hs
	$(GHCMAKE) configure
	./configure

git-annex.1:
	./mdwn2man git-annex 1 doc/git-annex.mdwn > git-annex.1

git-annex: SysConfig.hs
	$(GHCMAKE) git-annex

install: all
	install -d $(DESTDIR)$(PREFIX)/bin
	install git-annex $(DESTDIR)$(PREFIX)/bin
	install -d $(DESTDIR)$(PREFIX)/share/man/man1
	install -m 0644 git-annex.1 $(DESTDIR)$(PREFIX)/share/man/man1
	install -d $(DESTDIR)$(PREFIX)/share/doc/git-annex
	if [ -d html ]; then \
		rsync -a --delete html/ $(DESTDIR)$(PREFIX)/share/doc/git-annex/html/; \
	fi

test:
	$(GHCMAKE) test
	./test

# If ikiwiki is available, build static html docs suitable for being
# shipped in the software package.
ifeq ($(shell which ikiwiki),)
IKIWIKI=@echo "** ikiwiki not found, skipping building docs" >&2; true
else
IKIWIKI=ikiwiki
endif

docs: git-annex.1
	$(IKIWIKI) doc html -v --wikiname git-annex --plugin=goodstuff \
		--no-usedirs --disable-plugin=openid --plugin=sidebar \
		--underlaydir=/dev/null --disable-plugin=shortcut \
		--disable-plugin=smiley \
		--exclude='news/.*'

clean:
	rm -rf build git-annex git-annex.1 test configure SysConfig.hs
	rm -rf doc/.ikiwiki html

.PHONY: git-annex test install

=== debian/changelog ===
git-annex (0.14) unstable; urgency=low

  * Bugfix to git annex unused in a repository with nothing yet annexed.
  * Support upgrading from a v0 annex with nothing in it.
  * Avoid multiple calls to git ls-files when passed eg, "*".

 -- Joey Hess <joeyh@debian.org>  Fri, 24 Dec 2010 17:38:48 -0400

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: git-annex
 Section: utils
 Priority: optional
-Build-Depends: debhelper (>= 7.0.50), ghc6, libghc6-missingh-dev, libghc6-testpack-dev, ikiwiki, uuid, rsync
+Build-Depends: debhelper (>= 7.0.50), ghc6, libghc6-missingh-dev, libghc6-pcre-light-dev, libghc6-testpack-dev, ikiwiki, uuid, rsync
 Maintainer: Joey Hess <joeyh@debian.org>
 Standards-Version: 3.9.1
 Vcs-Git: git://git.kitenet.net/git-annex

## git-annex 0.20110427

=== Makefile ===
PREFIX=/usr
IGNORE=-ignore-package monads-fd
GHCFLAGS=-O2 -Wall $(IGNORE)
ifdef PROFILE
GHCFLAGS=-prof -auto-all -rtsopts -caf-all -fforce-recomp $(IGNORE)
endif
GHCMAKE=ghc $(GHCFLAGS) --make

bins=git-annex git-annex-shell
mans=git-annex.1 git-annex-shell.1

all: $(bins) $(mans) docs

SysConfig.hs: configure.hs TestConfig.hs
	$(GHCMAKE) configure
	./configure

%.hs: %.hsc
	hsc2hs $<
	perl -i -pe 's/^{-# INCLUDE.*//' $@

Remote/S3.o:
	@ln -sf S3real.hs Remote/S3.hs
	@if ! $(GHCMAKE) Remote/S3.hs; then \
		ln -sf S3stub.hs Remote/S3.hs; \
		echo "** building without S3 support"; \
	fi

$(bins): SysConfig.hs Touch.hs StatFS.hs Remote/S3.o
	$(GHCMAKE) $@

git-annex.1: doc/git-annex.mdwn
	./mdwn2man git-annex 1 doc/git-annex.mdwn > git-annex.1
git-annex-shell.1: doc/git-annex-shell.mdwn
	./mdwn2man git-annex-shell 1 doc/git-annex-shell.mdwn > git-annex-shell.1

install: all
	install -d $(DESTDIR)$(PREFIX)/bin
	install $(bins) $(DESTDIR)$(PREFIX)/bin
	install -d $(DESTDIR)$(PREFIX)/share/man/man1
	install -m 0644 $(mans) $(DESTDIR)$(PREFIX)/share/man/man1
	install -d $(DESTDIR)$(PREFIX)/share/doc/git-annex
	if [ -d html ]; then \
		rsync -a --delete html/ $(DESTDIR)$(PREFIX)/share/doc/git-annex/html/; \
	fi

test: $(bins)
	if ! $(GHCMAKE) test; then \
		echo "** not running test suite" >&2; \
	else \
		./test; \
	fi

testcoverage: $(bins)
	rm -f test.tix test
	ghc -odir build/test -hidir build/test $(GHCFLAGS) --make -fhpc test
	./test
	@echo ""
	@hpc report test --exclude=Main --exclude=QC
	@hpc markup test --exclude=Main --exclude=QC --destdir=.hpc >/dev/null

# If ikiwiki is available, build static html docs suitable for being
# shipped in the software package.
ifeq ($(shell which ikiwiki),)
IKIWIKI=@echo "** ikiwiki not found, skipping building docs" >&2; true
else
IKIWIKI=ikiwiki
endif

docs: $(mans)
	$(IKIWIKI) doc html -v --wikiname git-annex --plugin=goodstuff \
		--no-usedirs --disable-plugin=openid --plugin=sidebar \
		--underlaydir=/dev/null --disable-plugin=shortcut \
		--disable-plugin=smiley \
		--plugin=comments --set comments_pagespec="*" \
		--exclude='news/.*'

clean:
	rm -rf build $(bins) $(mans) test configure  *.tix .hpc \
		StatFS.hs Touch.hs SysConfig.hs Remote/S3.hs
	rm -rf doc/.ikiwiki html
	find . \( -name \*.o -or -name \*.hi \) -exec rm {} \;

.PHONY: $(bins) test install

=== debian/changelog ===
git-annex (0.20110427) unstable; urgency=low

  * Switch back to haskell SHA library, so git-annex remains buildable on
    Debian stable.
  * Added rsync special remotes. This could be used, for example, to 
    store annexed content on rsync.net (encrypted naturally). Or anywhere else.
  * Bugfix: Avoid pipeline stall when running git annex drop or fsck on a
    lot of files. Possibly only occured with ghc 7.

 -- Joey Hess <joeyh@debian.org>  Wed, 27 Apr 2011 22:50:26 -0400

git-annex (0.20110425) unstable; urgency=low

  * Use haskell Crypto library instead of haskell SHA library.
  * Remove testpack from build depends for non x86 architectures where it
    is not available. The test suite will not be run if it cannot be compiled.
  * Avoid using absolute paths when staging location log, as that can
    confuse git when a remote's path contains a symlink. Closes: #621386

 -- Joey Hess <joeyh@debian.org>  Mon, 25 Apr 2011 15:47:00 -0400

git-annex (0.20110420) unstable; urgency=low

  * Update Debian build dependencies for ghc 7.
  * Debian package is now built with S3 support.
    Thanks Joachim Breitner for making this possible.
  * Somewhat improved memory usage of S3, still work to do.
    Thanks Greg Heartsfield for ongoing work to improve the hS3 library
    for git-annex.

 -- Joey Hess <joeyh@debian.org>  Thu, 21 Apr 2011 15:00:48 -0400

git-annex (0.20110419) unstable; urgency=low

  * Don't run gpg in batch mode, so it can prompt for passphrase when
    there is no agent.
  * Add missing build dep on dataenc.
  * S3: Fix stalls when transferring encrypted data.
  * bup: Avoid memory leak when transferring encrypted data.

 -- Joey Hess <joeyh@debian.org>  Tue, 19 Apr 2011 21:26:51 -0400

git-annex (0.20110417) unstable; urgency=low

  * bup is now supported as a special type of remote.
  * The data sent to special remotes (Amazon S3, bup, etc) can be encrypted
    using GPG for privacy.
  * Use lowercase hash directories for locationlog files, to avoid
    some issues with git on OSX with the mixed-case directories.
    No migration is needed; the old mixed case hash directories are still
    read; new information is written to the new directories.
  * Unused files on remotes, particulary special remotes, can now be
    identified and dropped, by using "--from remote" with git annex unused
    and git annex dropunused.
  * Clear up short option confusion between --from and --force (-f is now
    --from, and there is no short option for --force).
  * Add build depend on perlmagick so docs are consistently built.
    Closes: #621410
  * Add doc-base file. Closes: #621408
  * Periodically flush git command queue, to avoid boating memory usage
    too much.
  * Support "sha1" and "sha512" commands on FreeBSD, and allow building
    if any/all SHA commands are not available. Thanks, Fraser Tweedale

 -- Joey Hess <joeyh@debian.org>  Sun, 17 Apr 2011 12:00:24 -0400

git-annex (0.20110401) experimental; urgency=low

  * Amazon S3 is now supported as a special type of remote.
    Warning: Encrypting data before sending it to S3 is not yet supported.
  * Note that Amazon S3 support is not built in by default on Debian yet,
    as hS3 is not packaged.
  * fsck: Ensure that files and directories in .git/annex/objects
    have proper permissions.
  * Added a special type of remote called a directory remote, which
    simply stores files in an arbitrary local directory.
  * Bugfix: copy --to --fast never really copied, fixed.

 -- Joey Hess <joeyh@debian.org>  Fri, 01 Apr 2011 21:27:22 -0400

git-annex (0.20110328) experimental; urgency=low

  * annex.diskreserve can be given in arbitrary units (ie "0.5 gigabytes")
  * Generalized remotes handling, laying groundwork for remotes that are
    not regular git remotes. (Think Amazon S3.)
  * Provide a less expensive version of `git annex copy --to`, enabled
    via --fast. This assumes that location tracking information is correct,
    rather than contacting the remote for every file.
  * Bugfix: Keys could be received into v1 annexes from v2 annexes, via
    v1 git-annex-shell. This results in some oddly named keys in the v1
    annex. Recognise and fix those keys when upgrading, instead of crashing.

 -- Joey Hess <joeyh@debian.org>  Mon, 28 Mar 2011 10:47:29 -0400

git-annex (0.20110325) experimental; urgency=low

  * Free space checking is now done, for transfers of data for keys
    that have free space metadata. (Notably, not for SHA* keys generated
    with git-annex 0.2x or earlier.) The code is believed to work on
    Linux, FreeBSD, and OSX; check compile-time messages to see if it
    is not enabled for your OS.
  * Add annex.diskreserve config setting, to control how much free space
    to reserve for other purposes and avoid using (defaults to 1 mb).
  * Add --fast flag, that can enable less expensive, but also less thorough
    versions of some commands.
  * fsck: In fast mode, avoid checking checksums.
  * unused: In fast mode, just show all existing temp files as unused,
    and avoid expensive scan for other unused content.
  * migrate: Support migrating v1 SHA keys to v2 SHA keys with
    size information that can be used for free space checking.
  * Fix space leak in fsck and drop commands.
  * migrate: Bugfix for case when migrating a file results in a key that
    is already present in .git/annex/objects.
  * dropunused: Significantly sped up; only read unused log file once.

 -- Joey Hess <joeyh@debian.org>  Fri, 25 Mar 2011 00:47:37 -0400

git-annex (0.20110320) experimental; urgency=low

  * Fix dropping of files using the URL backend.
  * Fix support for remotes with '.' in their names.
  * Add version command to show git-annex version as well as repository
    version information.
  * No longer auto-upgrade to repository format 2, to avoid accidental
    upgrades, etc. Use git-annex upgrade when you're ready to run this
    version.

 -- Joey Hess <joeyh@debian.org>  Sun, 20 Mar 2011 16:36:33 -0400



## git-annex 0.20110503

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 PREFIX=/usr
 IGNORE=-ignore-package monads-fd
-GHCFLAGS=-O2 -Wall $(IGNORE)
+GHCFLAGS=-O2 -Wall $(IGNORE) -fspec-constr-count=5
 ifdef PROFILE
 GHCFLAGS=-prof -auto-all -rtsopts -caf-all -fforce-recomp $(IGNORE)
 endif

=== debian/changelog ===
git-annex (0.20110503) unstable; urgency=low

  * Fix hasKeyCheap setting for bup and rsync special remotes.
  * Add hook special remotes.
  * Avoid crashing when an existing key is readded to the annex.
  * unused: Now also lists files fsck places in .git/annex/bad/
  * S3: When encryption is enabled, the Amazon S3 login credentials
    are stored, encrypted, in .git-annex/remotes.log, so environment
    variables need not be set after the remote is initialized.

 -- Joey Hess <joeyh@debian.org>  Tue, 03 May 2011 20:56:01 -0400

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,21 @@
 Source: git-annex
 Section: utils
 Priority: optional
-Build-Depends: debhelper (>= 7.0.50), ghc6, libghc6-missingh-dev, libghc6-pcre-light-dev, libghc6-testpack-dev, ikiwiki, uuid, rsync
+Build-Depends: 
+	debhelper (>= 7.0.50),
+	ghc,
+	libghc-missingh-dev,
+	libghc-pcre-light-dev,
+	libghc-sha-dev,
+	libghc-dataenc-dev,
+	libghc-utf8-string-dev,
+	libghc-hs3-dev (>= 0.5.6),
+	libghc-testpack-dev [any-i386 any-amd64],
+	ikiwiki,
+	perlmagick,
+	git | git-core,
+	uuid,
+	rsync,
 Maintainer: Joey Hess <joeyh@debian.org>
 Standards-Version: 3.9.1
 Vcs-Git: git://git.kitenet.net/git-annex
@@ -10,7 +24,12 @@
 Package: git-annex
 Architecture: any
 Section: utils
-Depends: ${misc:Depends}, ${shlibs:Depends}, git | git-core, uuid, openssh-client, rsync
+Depends: ${misc:Depends}, ${shlibs:Depends},
+	git | git-core,
+	uuid,
+	rsync,
+	openssh-client
+Suggests: graphviz, bup, gnupg
 Description: manage files with git, without checking their contents into git
  git-annex allows managing files with git, without checking the file
  contents into git. While that may seem paradoxical, it is useful when

## git-annex 0.20110516

=== Makefile ===
--- 
+++ 
@@ -45,7 +45,7 @@
 	fi
 
 test: $(bins)
-	if ! $(GHCMAKE) test; then \
+	if ! $(GHCMAKE) -O0 test; then \
 		echo "** not running test suite" >&2; \
 	else \
 		./test; \

=== debian/changelog ===
git-annex (0.20110516) unstable; urgency=low

  * Add a few tweaks to make it easy to use the Internet Archive's variant
    of S3. In particular, munge key filenames to comply with the IA's filename
    limits, disable encryption, support their nonstandard way of creating
    buckets, and allow x-archive-* headers to be specified in initremote to
    set item metadata.
  * Added filename extension preserving variant backends SHA1E, SHA256E, etc.
  * migrate: Use current filename when generating new key, for backends
    where the filename affects the key name.
  * Work around a bug in Network.URI's handling of bracketed ipv6 addresses.

 -- Joey Hess <joeyh@debian.org>  Mon, 16 May 2011 14:16:52 -0400

=== debian/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
 	uuid,
 	rsync,
 Maintainer: Joey Hess <joeyh@debian.org>
-Standards-Version: 3.9.1
+Standards-Version: 3.9.2
 Vcs-Git: git://git.kitenet.net/git-annex
 Homepage: http://git-annex.branchable.com/

## git-annex 0.20110521

=== debian/changelog ===
git-annex (0.20110521) unstable; urgency=low

  * status: New subcommand to show info about an annex, including its size.
  * --backend now overrides any backend configured in .gitattributes files.
  * Add --debug option. Closes: #627499

 -- Joey Hess <joeyh@debian.org>  Sat, 21 May 2011 11:52:53 -0400

## git-annex 0.20110522

=== debian/changelog ===
git-annex (0.20110522) unstable; urgency=low

  * Closer emulation of git's behavior when told to use "foo/.git" as a
    git repository instead of just "foo". Closes: #627563
  * Fix bug in --exclude introduced in 0.20110516.

 -- Joey Hess <joeyh@debian.org>  Fri, 27 May 2011 20:20:41 -0400

=== debian/control ===
--- 
+++ 
@@ -5,6 +5,7 @@
 	debhelper (>= 7.0.50),
 	ghc,
 	libghc-missingh-dev,
+	libghc-hslogger-dev,
 	libghc-pcre-light-dev,
 	libghc-sha-dev,
 	libghc-dataenc-dev,

## git-annex 0.20110601

=== debian/changelog ===
git-annex (0.20110601) unstable; urgency=low

  * Minor bugfixes and error message improvements.
  * Massively sped up `git annex lock` by avoiding use of the uber-slow
    `git reset`, and only running `git checkout` once, even when many files
    are being locked.
  * Fix locking of files with staged changes.
  * Somewhat sped up `git commit` of modifications to unlocked files.
  * Build fix for older ghc.

 -- Joey Hess <joeyh@debian.org>  Wed, 01 Jun 2011 11:50:47 -0400

## git-annex 0.20110610

=== debian/changelog ===
git-annex (0.20110610) unstable; urgency=low

  * Add --numcopies option.
  * Add --trust, --untrust, and --semitrust options.
  * get --from is the same as copy --from
  * Bugfix: Fix fsck to not think all SHAnE keys are bad.

 -- Joey Hess <joeyh@debian.org>  Fri, 10 Jun 2011 11:48:40 -0400

## git-annex 3.20110719

=== Makefile ===
--- 
+++ 
@@ -6,10 +6,12 @@
 endif
 GHCMAKE=ghc $(GHCFLAGS) --make
 
-bins=git-annex git-annex-shell
-mans=git-annex.1 git-annex-shell.1
+bins=git-annex git-annex-shell git-union-merge
+mans=git-annex.1 git-annex-shell.1 git-union-merge.1
 
 all: $(bins) $(mans) docs
+
+sources: SysConfig.hs StatFS.hs Touch.hs Remote/S3.hs
 
 SysConfig.hs: configure.hs TestConfig.hs
 	$(GHCMAKE) configure
@@ -19,8 +21,10 @@
 	hsc2hs $<
 	perl -i -pe 's/^{-# INCLUDE.*//' $@
 
-Remote/S3.o:
+Remote/S3.hs:
 	@ln -sf S3real.hs Remote/S3.hs
+
+Remote/S3.o: Remote/S3.hs
 	@if ! $(GHCMAKE) Remote/S3.hs; then \
 		ln -sf S3stub.hs Remote/S3.hs; \
 		echo "** building without S3 support"; \
@@ -33,6 +37,8 @@
 	./mdwn2man git-annex 1 doc/git-annex.mdwn > git-annex.1
 git-annex-shell.1: doc/git-annex-shell.mdwn
 	./mdwn2man git-annex-shell 1 doc/git-annex-shell.mdwn > git-annex-shell.1
+git-union-merge.1: doc/git-union-merge.mdwn
+	./mdwn2man git-union-merge 1 doc/git-union-merge.mdwn > git-union-merge.1
 
 install: all
 	install -d $(DESTDIR)$(PREFIX)/bin
@@ -45,7 +51,7 @@
 	fi
 
 test: $(bins)
-	if ! $(GHCMAKE) -O0 test; then \
+	@if ! $(GHCMAKE) -O0 test; then \
 		echo "** not running test suite" >&2; \
 	else \
 		./test; \
@@ -78,7 +84,15 @@
 clean:
 	rm -rf build $(bins) $(mans) test configure  *.tix .hpc \
 		StatFS.hs Touch.hs SysConfig.hs Remote/S3.hs
-	rm -rf doc/.ikiwiki html
+	rm -rf doc/.ikiwiki html dist
 	find . \( -name \*.o -or -name \*.hi \) -exec rm {} \;
 
+# Workaround for cabal sdist not running Setup hooks, so I cannot
+# generate a file list there.
+sdist: clean
+	@if [ ! -e git-annex.cabal.orig ]; then cp git-annex.cabal git-annex.cabal.orig; fi
+	@sed -e "s!\(Extra-Source-Files: \).*!\1$(shell find . -name .git -prune -or -not -name \\*.orig -not -type d -print | perl -ne 'print unless length >= 100')!i" < git-annex.cabal.orig > git-annex.cabal
+	@cabal sdist
+	@mv git-annex.cabal.orig git-annex.cabal
+
 .PHONY: $(bins) test install

=== debian/changelog ===
git-annex (3.20110719) unstable; urgency=low

  * add: Be even more robust to avoid ever leaving the file seemingly deleted.
    Closes: #634233
  * Bugfix: Make add ../ work.
  * Support the standard git -c name=value
  * unannex: Clean up use of git commit -a.

 -- Joey Hess <joeyh@debian.org>  Tue, 19 Jul 2011 23:39:53 -0400

git-annex (3.20110707) unstable; urgency=low

  * Fix sign bug in disk free space checking.
  * Bugfix: Forgot to de-escape keys when upgrading. Could result in
    bad location log data for keys that contain [&:%] in their names.
    (A workaround for this problem is to run git annex fsck.)
  * add: Avoid a failure mode that resulted in the file seemingly being
    deleted (content put in the annex but no symlink present).

 -- Joey Hess <joeyh@debian.org>  Thu, 07 Jul 2011 19:29:39 -0400

git-annex (3.20110705) unstable; urgency=low

  * uninit: Delete the git-annex branch and .git/annex/
  * unannex: In --fast mode, file content is left in the annex, and a
    hard link made to it.
  * uninit: Use unannex in --fast mode, to support unannexing multiple
    files that link to the same content.
  * Drop the dependency on the haskell curl bindings, use regular haskell HTTP.
  * Fix a pipeline stall when upgrading (caused by #624389).

 -- Joey Hess <joeyh@debian.org>  Tue, 05 Jul 2011 14:37:39 -0400

git-annex (3.20110702) unstable; urgency=low

  * Now the web can be used as a special remote. 
    This feature replaces the old URL backend.
  * addurl: New command to download an url and store it in the annex.
  * Sped back up fsck, copy --from, and other commands that often
    have to read a lot of information from the git-annex branch. Such
    commands are now faster than they were before introduction of the
    git-annex branch.
  * Always ensure git-annex branch exists.
  * Modify location log parser to allow future expansion.
  * --force will cause add, etc, to operate on ignored files.
  * Avoid mangling encoding when storing the description of repository
    and other content.
  * cabal can now be used to build git-annex. This is substantially
    slower than using make, does not build or install documentation,
    does not run the test suite, and is not particularly recommended,
    but could be useful to some.

 -- Joey Hess <joeyh@debian.org>  Sat, 02 Jul 2011 15:00:18 -0400

git-annex (3.20110624) experimental; urgency=low

  * New repository format, annex.version=3. Use `git annex upgrade` to migrate.
  * git-annex now stores its logs in a git-annex branch.
  * merge: New subcommand. Auto-merges the new git-annex branch.
  * Improved handling of bare git repos with annexes. Many more commands will
    work in them.
  * git-annex is now more robust; it will never leave state files
    uncommitted when some other git process comes along and locks the index
    at an inconvenient time.
  * rsync is now used when copying files from repos on other filesystems.
    cp is still used when copying file from repos on the same filesystem,
    since --reflink=auto can make it significantly faster on filesystems
    such as btrfs.
  * Allow --trust etc to specify a repository by name, for temporarily 
    trusting repositories that are not configured remotes.
  * unlock: Made atomic.
  * git-union-merge: New git subcommand, that does a generic union merge
    operation, and operates efficiently without touching the working tree.

 -- Joey Hess <joeyh@debian.org>  Fri, 24 Jun 2011 14:32:18 -0400

=== debian/control ===
--- 
+++ 
@@ -9,9 +9,11 @@
 	libghc-pcre-light-dev,
 	libghc-sha-dev,
 	libghc-dataenc-dev,
+	libghc-http-dev,
 	libghc-utf8-string-dev,
 	libghc-hs3-dev (>= 0.5.6),
 	libghc-testpack-dev [any-i386 any-amd64],
+	libghc-monad-control-dev,
 	ikiwiki,
 	perlmagick,
 	git | git-core,

## git-annex 3.20111111

=== Makefile ===
--- 
+++ 
@@ -1,19 +1,31 @@
 PREFIX=/usr
 IGNORE=-ignore-package monads-fd
 GHCFLAGS=-O2 -Wall $(IGNORE) -fspec-constr-count=5
+
 ifdef PROFILE
 GHCFLAGS=-prof -auto-all -rtsopts -caf-all -fforce-recomp $(IGNORE)
 endif
+
 GHCMAKE=ghc $(GHCFLAGS) --make
 
 bins=git-annex git-annex-shell git-union-merge
 mans=git-annex.1 git-annex-shell.1 git-union-merge.1
+sources=Build/SysConfig.hs Utility/StatFS.hs Utility/Touch.hs Remote/S3.hs
 
-all: $(bins) $(mans) docs
+all=$(bins) $(mans) docs
 
-sources: SysConfig.hs StatFS.hs Touch.hs Remote/S3.hs
+# Am I typing :make in vim? Do a fast build.
+ifdef VIM
+all=fast
+endif
 
-SysConfig.hs: configure.hs TestConfig.hs
+all: $(all)
+
+# Disables optimisation. Not for production use.
+fast: GHCFLAGS=-Wall $(IGNORE)
+fast: $(bins)
+
+Build/SysConfig.hs: configure.hs Build/TestConfig.hs
 	$(GHCMAKE) configure
 	./configure
 
@@ -30,7 +42,9 @@
 		echo "** building without S3 support"; \
 	fi
 
-$(bins): SysConfig.hs Touch.hs StatFS.hs Remote/S3.o
+sources: $(sources)
+
+$(bins): sources Remote/S3.o
 	$(GHCMAKE) $@
 
 git-annex.1: doc/git-annex.mdwn
@@ -54,7 +68,10 @@
 	@if ! $(GHCMAKE) -O0 test; then \
 		echo "** not running test suite" >&2; \
 	else \
-		./test; \
+		if ! ./test; then \
+			echo "** test suite failed!" >&2; \
+			exit 1; \
+		fi; \
 	fi
 
 testcoverage: $(bins)
@@ -82,8 +99,7 @@
 		--exclude='news/.*'
 
 clean:
-	rm -rf build $(bins) $(mans) test configure  *.tix .hpc \
-		StatFS.hs Touch.hs SysConfig.hs Remote/S3.hs
+	rm -rf build $(bins) $(mans) test configure  *.tix .hpc $(sources)
 	rm -rf doc/.ikiwiki html dist
 	find . \( -name \*.o -or -name \*.hi \) -exec rm {} \;

=== debian/changelog ===
git-annex (3.20111111) unstable; urgency=low

  * Handle a case where an annexed file is moved into a gitignored directory,
    by having fix --force add its change.
  * Avoid cyclic drop problems.
  * Optimized copy --from and get --from to avoid checking the location log
    for files that are already present.
  * Automatically fix up badly formatted uuid.log entries produced by
    3.20111105, whenever the uuid.log is changed (ie, by init or describe).
  * map: Support remotes with /~/ and /~user/

 -- Joey Hess <joeyh@debian.org>  Fri, 11 Nov 2011 13:44:18 -0400

git-annex (3.20111107) unstable; urgency=low

  * merge: Use fast-forward merges when possible.
    Thanks Valentin Haenel for a test case showing how non-fast-forward
    merges could result in an ongoing pull/merge/push cycle.
  * Don't try to read config from repos with annex-ignore set.
  * Bugfix: In the past two releases, git-annex init has written the uuid.log
    in the wrong format, with the UUID and description flipped.

 -- Joey Hess <joeyh@debian.org>  Mon, 07 Nov 2011 12:47:44 -0400

git-annex (3.20111105) unstable; urgency=low

  * The default backend used when adding files to the annex is changed
    from WORM to SHA256.
    To get old behavior, add a .gitattributes containing: * annex.backend=WORM
  * Sped up some operations on remotes that are on the same host.
  * copy --to: Fixed leak when copying many files to a remote on the same
    host.
  * uninit: Add guard against being run with the git-annex branch checked out.
  * Fail if --from or --to is passed to commands that do not support them.
  * drop --from is now supported to remove file content from a remote.
  * status: Now always shows the current repository, even when it does not
    appear in uuid.log.
  * fsck: Now works in bare repositories. Checks location log information,
    and file contents. Does not check that numcopies is satisfied, as
    .gitattributes information about numcopies is not available in a bare
    repository.
  * unused, dropunused: Now work in bare repositories.
  * Removed the setkey command, and added a reinject command with a more
    useful interface.
  * The fromkey command now takes the key as its first parameter. The --key
    option is no longer used.
  * Built without any filename containing .git being excluded. Closes: #647215
  * Record uuid when auto-initializing a remote so it shows in status.
  * Bugfix: Fixed git-annex init crash in a bare repository when there was
    already an existing git-annex branch.
  * Pass -t to rsync to preserve timestamps.

 -- Joey Hess <joeyh@debian.org>  Sat, 05 Nov 2011 15:47:52 -0400

git-annex (3.20111025) unstable; urgency=low

  * A remote can have a annexUrl configured, that is used by git-annex
    instead of its usual url. (Similar to pushUrl.)
  * migrate: Copy url logs for keys when migrating.
  * git-annex-shell: GIT_ANNEX_SHELL_READONLY and GIT_ANNEX_SHELL_LIMITED
    environment variables can be set to limit what commands can be run.
    This is used by gitolite's new git-annex support!

 -- Joey Hess <joeyh@debian.org>  Tue, 25 Oct 2011 13:03:08 -0700

git-annex (3.20111011) unstable; urgency=low

  * This version of git-annex only works with git 1.7.7 and newer.
    The breakage with old versions is subtle, and affects the
    annex.numcopies settings in .gitattributes, so be sure to upgrade git
    to 1.7.7. (Debian package now depends on that version.)
  * Don't pass absolute paths to git show-attr, as it started following
    symlinks when that's done in 1.7.7. Instead, use relative paths,
    which show-attr only handles 100% correctly in 1.7.7. Closes: #645046
  * Fix referring to remotes by uuid.
  * New or changed repository descriptions in uuid.log now have a timestamp,
    which is used to ensure the newest description is used when the uuid.log
    has been merged.
  * Note that older versions of git-annex will display the timestamp as part
    of the repository description, which is ugly but otherwise harmless.
  * Add timestamps to trust.log and remote.log too.
  * git-annex-shell: Added the --uuid option.
  * git-annex now asks git-annex-shell to verify that it's operating in 
    the expected repository.
  * Note that this git-annex will not interoperate with remotes using 
    older versions of git-annex-shell.
  * Now supports git's insteadOf configuration, to modify the url
    used to access a remote. Note that pushInsteadOf is not used;
    that and pushurl are reserved for actual git pushes. Closes: #644278
  * status: List all known repositories.
  * When displaying a list of repositories, show git remote names
    in addition to their descriptions.
  * Add locking to avoid races when changing the git-annex branch.
  * Various speed improvements gained by using ByteStrings.
  * Contain the zombie hordes.

 -- Joey Hess <joeyh@debian.org>  Tue, 11 Oct 2011 23:00:02 -0400

git-annex (3.20110928) unstable; urgency=low

  * --in can be used to make git-annex only operate on files
    believed to be present in a given repository.
  * Arbitrarily complex expressions can be built to limit the files git-annex
    operates on, by combining the options --not --and --or -( and -)
    Example: git annex get --exclude '*.mp3' --and --not -( --in usbdrive --or --in archive -)
  * --copies=N can be used to make git-annex only operate on files with
    the specified number of copies. (And --not --copies=N for the inverse.)
  * find: Rather than only showing files whose contents are present,
    when used with --exclude --copies or --in, displays all files that
    match the specified conditions.
  * Note that this is a behavior change for git-annex find! Old behavior
    can be gotten by using: git-annex find --in .
  * status: Massively sped up; remove --fast mode.
  * unused: File contents used by branches and tags are no longer
    considered unused, even when not used by the current branch. This is


=== debian/control ===
--- 
+++ 
@@ -14,9 +14,10 @@
 	libghc-hs3-dev (>= 0.5.6),
 	libghc-testpack-dev [any-i386 any-amd64],
 	libghc-monad-control-dev,
+	libghc-json-dev,
 	ikiwiki,
 	perlmagick,
-	git | git-core,
+	git,
 	uuid,
 	rsync,
 Maintainer: Joey Hess <joeyh@debian.org>
@@ -28,9 +29,10 @@
 Architecture: any
 Section: utils
 Depends: ${misc:Depends}, ${shlibs:Depends},
-	git | git-core,
+	git (>= 1:1.7.7),
 	uuid,
 	rsync,
+	wget | curl,
 	openssh-client
 Suggests: graphviz, bup, gnupg
 Description: manage files with git, without checking their contents into git

## git-annex 3.20111122

=== debian/changelog ===
git-annex (3.20111122) unstable; urgency=low

  * merge: Improve commit messages to mention what was merged.
  * Avoid doing auto-merging in commands that don't need fully current
    information from the git-annex branch. In particular, git annex add
    no longer needs to auto-merge.
  * init: When run in an already initalized repository, and without
    a description specified, don't delete the old description. 
  * Optimised union merging; now only runs git cat-file once, and runs
    in constant space.
  * status: Now displays trusted, untrusted, and semitrusted repositories
    separately.
  * status: Include all special remotes in the list of repositories.
  * status: Fix --json mode.
  * status: --fast is back
  * Fix support for insteadOf url remapping. Closes: #644278
  * When not run in a git repository, git-annex can still display a usage
    message, and "git annex version" even works.
  * migrate: Don't fall over a stale temp file.
  * Avoid excessive escaping for rsync special remotes that are not accessed
    over ssh.
  * find: Support --print0

 -- Joey Hess <joeyh@debian.org>  Tue, 22 Nov 2011 14:31:45 -0400

## git-annex 3.20111211

=== debian/changelog ===
git-annex (3.20111211) unstable; urgency=medium

  * Fix bug in last version in getting contents from bare repositories.
  * Ensure that git-annex branch changes are merged into git-annex's index,
    which fixes a bug that could cause changes that were pushed to the
    git-annex branch to get reverted. As a side effect, it's now safe
    for users to check out and commit changes directly to the git-annex
    branch.
  * map: Fix a failure to detect a loop when both repositories are local
    and refer to each other with relative paths.
  * Prevent key names from containing newlines.
  * add: If interrupted, add can leave files converted to symlinks but not
    yet added to git. Running the add again will now clean up this situtation.
  * Fix caching of decrypted ciphers, which failed when drop had to check
    multiple different encrypted special remotes.
  * unannex: Can be run on files that have been added to the annex, but not
    yet committed.
  * sync: New command that synchronises the local repository and default
    remote, by running git commit, pull, and push for you.
  * Version monad-control dependency in cabal file.

 -- Joey Hess <joeyh@debian.org>  Sun, 11 Dec 2011 21:24:39 -0400

git-annex (3.20111203) unstable; urgency=low

  * The VFAT filesystem on recent versions of Linux, when mounted with
    shortname=mixed, does not get along well with git-annex's mixed case
    .git/annex/objects hash directories. To avoid this problem, new content
    is now stored in all-lowercase hash directories. Except for non-bare
    repositories which would be a pain to transition and cannot be put on FAT.
    (Old mixed-case hash directories are still tried for backwards
    compatibility.)
  * Flush json output, avoiding a buffering problem that could result in
    doubled output.
  * Avoid needing haskell98 and other fixes for new ghc. Thanks, Mark Wright.
  * Bugfix: dropunused did not drop keys with two spaces in their name.
  * Support for storing .git/annex on a different device than the rest of the
    git repository.
  * --inbackend can be used to make git-annex only operate on files
    whose content is stored using a specified key-value backend.
  * dead: A command which says that a repository is gone for good
    and you don't want git-annex to mention it again.

 -- Joey Hess <joeyh@debian.org>  Sat, 03 Dec 2011 21:01:45 -0400
